> For the complete documentation index, see [llms.txt](https://docs.bluefletch.com/bluefletch-enterprise/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.bluefletch.com/bluefletch-enterprise/product-guides/device-applications/epm-plugin/features.md).

# Features

## Overview

The EPM Plugin uses Android's **Accessibility Settings** to read the content of the current page and auto-fill and click on text links or buttons as needed, based on configuration.

To grant Accessibility access to the EPM plugin across a fleet of device, consider BlueFletch's [Accessibility Enabler](/bluefletch-enterprise/product-guides/device-applications/accessibility-enabler.md).

## User Guide: An Example Flow & Config

When a page change is detected on the device:

1. EPM will read the text content on the page.
2. For each `action` object:
   1. EPM will check if any of the strings in `pageText` is found in the page. If any of the strings is in the page, EPM will set this as the current `action`*.*
3. EPM will then traverse the page and look for the username and password fields and submit buttons based on the hints (`usernameHints`, `passwordHints`) provided. In the Microsoft Power Apps example below:
   1. EPM will auto-fill the captured username in the input field that has the hint text "Username".
   2. EPM will auto-fill the captured password in the input field that has the hint text "Password".
   3. EPM will click on the button labeled "Next" or "Sign in".
4. Typically when the incorrect credentials are entered, the page will change to indicate an error. When a page change occurs for this, EPM will check the `haltOnErrorHints` section, and if that error string exists in the page, it will halt processing. This is used to prevent sending the same incorrect credentials repeatedly to the page.

**Example epmPluginConfig:**

```json
    "epmPluginConfig": {
        "settings": {
            "overlayHeightPct" : 100,
            "cardColor" : "#FFFFFF"
        },
        "actions": [
            {
                "actionId" : "MS Apps Action",
                "credentialId": "azure_creds",
                "packages": "com.microsoft.msapps",
                "pageText" : [
                   "Enter username"
                ],
                "usernameHints": [
                    "Username"
                ],
                "passwordHints": [
                    "Password"
                ],
                "submitButtonHints": [
                    "Next", "Sign in"
                ],
                "haltOnErrorHints": [
                    "Invalid username or password"
                ]
            },
            // .. more actions
        ]
    }
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.bluefletch.com/bluefletch-enterprise/product-guides/device-applications/epm-plugin/features.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
